#include "qjs_debug.h"
#include "qjs_macros.h"
#include "jsffi.h"

JSC_CCALL(debug_stack_depth, return number2js(js,js_debugger_stack_depth(js)))
JSC_CCALL(debug_build_backtrace, return js_debugger_build_backtrace(js,NULL))
JSC_CCALL(debug_closure_vars, return js_debugger_closure_variables(js,argv[0]))
JSC_CCALL(debug_local_vars, return js_debugger_local_variables(js, js2number(js,argv[0])))
JSC_CCALL(debug_fn_info, return js_debugger_fn_info(js, argv[0]))
JSC_CCALL(debug_backtrace_fns, return js_debugger_backtrace_fns(js,NULL))

static const JSCFunctionListEntry js_debug_funcs[] = {
  MIST_FUNC_DEF(debug, stack_depth, 0),
  MIST_FUNC_DEF(debug, build_backtrace, 0),
  MIST_FUNC_DEF(debug, closure_vars, 1),
  MIST_FUNC_DEF(debug, local_vars, 1),
  MIST_FUNC_DEF(debug, fn_info, 1),
  MIST_FUNC_DEF(debug, backtrace_fns,0),
};

JSValue js_debug_use(JSContext *js) {
  JSValue mod = JS_NewObject(js);
  JS_SetPropertyFunctionList(js,mod,js_debug_funcs,countof(js_debug_funcs));
  return mod;
}